# wasm-pack plugin

This is a drone/woodpecker plugin for building and publishing wasm-pack packages.

When using this plugin it is best to pull every time since it can be updated often internally.


## Settings

- `actions` (required): Actions (see below) to run
- `folder`: Project folder
- `scope`: NPM package scope

### Build

- `profile` (default=`release`): Build profile to use for `wasm-pack build`
- `target` (default=`bundler`): Target to build for
- `make`: Optionally run a make target building

### Test
(No options)

### Publish

- `username` (required): NPM registry username
- `token` (required): NPM registry auth token (secret recommended)
- `registry` (default=`https://registry.npmjs.org`): NPM registry to publish to

## Example
Taken from [wasm-o-x-rust.yml](../../.woodpecker/wasm-o-x-rust.yml)
```yaml
pipeline:
  build and publish:
    image: git.koval.net/cyclane/game-algorithms/wasm-pack-plugin
    pull: true
    settings:
      actions: build,publish
      folder: wasm/o-x-rust
      scope: game-algorithms
      username: cyclane
      token:
        from_secret: DEPLOY_TOKEN
      registry: https://git.koval.net/api/packages/cyclane/npm/
```
